const league = require('./league.js');
const period = require('./period.js');
const countryCode = require('./countryCode.js');
const market = require('./market.js');
const stats = require('./stats.js');
const country = require('./country.js');
const flagcode = require('./flagcode.js');
const betradereachpush = require('./models/Betradereachpush')
const betradereachpushraw = require('./models/Betradereachpushraw')
const betraderresults = require('./models/Betraderresults')
const subsriptionTable = require('./models/SubsriptionTable')
var MongoClient = require('mongodb').MongoClient;
var url = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@127.0.0.1:27017/admin";
const mongoose = require("mongoose");
const Betradereachpushraw = require('./models/Betradereachpushraw');
mongoose.set('strictQuery', false)
//const clusterURI = "mongodb+srv://mongouser:dbZCiED9F65gAbKc@cluster0.otpkk.mongodb.net/winpars_db?retryWrites=true&w=majority";
const clusterURI = "mongodb+srv://winpars:6FA6gPp7CRyFQ028@cluster1.2aesn.mongodb.net/winpars_db?retryWrites=true&w=majority";
const localURI = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@127.0.0.1:27017/winpars_db";
mongoose.connect(localURI).then(()=>{
    console.log("Connection done");
}).catch((err)=>{
    console.log(err);
})
// var redis = require('redis');
// var client = redis.createClient();
var leagues      = league.leagues().league;
var periods      = period.periods().period;
var countryCodes = countryCode.countryCodes().countryCode;
var markets      = market.markets().market;
var statss       = stats.stats().stats;
var countries    = country.countries().country;
var flagcodes    = flagcode.flagCodes();


function getHRMIN(tm) {
  let hr = Math.floor(tm/3600);
  let min = Math.floor(tm/60);
  min = min+hr;
  let sec = tm%60;
  let final = min+':'+sec;
  return final;
}
function getFlag(event) {
  if(array_key_exists(event.ct,flagcodes)){
    return flagcodes[event.ct].code;
  }else if (flagcodes[event.ct]!==undefined) {
    return flagcodes[event.ct].code;
  }
  else{
    return "nill";
  }

}
function getCountry(event) {
  let country_map = countryCodes[event.sp];
  // console.log(country_map);
  // return country_map[event.lg].code;
  if(array_key_exists(event.lg,country_map)){
    return country_map[event.lg].code;
  }else if (country_map[event.lg]!==undefined) {
    return country_map[event.lg].code;
  }else{
    return "team";
  }
}
function get_league(id){
  for (var i = 0; i < leagues.length; i++) {
    if(leagues[i].ID==id){
      for (var j = 0; j < countries.length; j++) {
        if(countries[j].ID==leagues[i].C){
          return countries[j].Name+' '+leagues[i].Name;
        }
      }

    }
  }
}
function getPeriod(event) {
  for (var i = 0; i < periods.length; i++) {
    // console.log(periods[i]);
    if(periods[i].pc==event.pc && periods[i].s==event.sp){
      return periods[i].pcName;
    }
  }
}
function getScore(event) {
  if(event.sp==1){
    return event.stats['a'][0]+':'+event.stats['a'][1];
  }
  if(event.sp==18){
    // console.log(event.stats);

    if(array_key_exists('T',event.stats)){
      return event.stats['T'][0]+':'+event.stats['T'][1];
    }else if (event.stats['T']!==undefined) {
      return event.stats['T'][0]+':'+event.stats['T'][1];

    }else{
      return '0:0';
    }

  }
  if(event.sp==13){
    var score = new Array();
    var stats = event.stats;
    for (var i = 0; i < stats.length; i++) {
        if(stats[i].name.includes("S")){
          score.push(stats[i][0]+':'+stats[i][1]);
        }
    }
    return score.join();
  }
  if(event.sp==91){
    var home = 0;
    var away = 0;
    var stats = event.stats;
    for (var i = 0; i < stats.length; i++) {
        if(stats[i].name.includes("S")){
          if(stats[i][0]>stats[i][1]){
            home++;
          }
          if(stats[i][0]<stats[i][1]){
            away++;
          }
        }
    }
    return home+':'+away;
  }
}

function getMatchBetween(event) {
  return event.T1.n+' vs '+event.T2.n;
}
function getSportName(id) {
  if(id==1){
    return "Football";
  }
  if(id==13){
    return "Tennis";
  }
  if(id==18){
    return "Basketball";
  }
  if(id==91){
    return "Volleyball";
  }
}
function makeStates(event) {
  let data = new Array();
  let stats = event.stats;
  data.push({"Name":"Team","home":event.T1.n,"away":event.T2.n});
  // for (var i = 0; i < stats.length; i++) {
  //
  // }
  Object.keys(stats).forEach(function(key) {
  // console.log('Key : ' + key + ', Value : ' + stats[key])
      for (var j = 0; j < statss.length; j++) {
          if(key==statss[j].c && statss[j].s==event.sp){
            data.push({"Name":statss[j].e,"home":stats[key][0],"away":stats[key][1]});
          }
      }
    })
  return data;
}
function array_key_exists(needle, haystack) {
    // var length = haystack.length;
    // for(var i = 0; i < length; i++) {
    //     if(haystack[i] == needle) return true;
    // }
    // return false;
      var flag = false;
      // if(Array.isArray(haystack)){
      if(typeof haystack === 'object' && haystack !== null){
        Object.keys(haystack).forEach(function(key) {
          if(key==needle){
            flag  = true;
          }
        });
      }

    return flag;
}
function makeOdds(event) {
  let livemarkets = markets[event.sp];
  // console.log(markets);
  let eventmarket = event.ma;
  for (var i = 0; i < eventmarket.length; i++) {
      eventmarket[i].id = eventmarket[i].b3i;
      if(array_key_exists(eventmarket[i].id,livemarkets)){
        eventmarket[i].name =livemarkets[eventmarket[i].id];
        eventmarket[i].short_name = livemarkets[eventmarket[i].id];
      }else if (livemarkets[eventmarket[i].id]!==undefined) {
        eventmarket[i].name =livemarkets[eventmarket[i].id];
        eventmarket[i].short_name = livemarkets[eventmarket[i].id];
      }else{
        eventmarket[i].name = 'Market Not Defined';
        eventmarket[i].short_name = 'Market Not Defined';
      }

      if(array_key_exists('ha',eventmarket[i])){
        eventmarket[i].handicap = eventmarket[i].ha;
      }
      // eventmarket[i].name =markets[eventmarket[i].id];
      // eventmarket[i].short_name = markets[eventmarket[i].id];
      eventmarket[i].suspend =eventmarket[i].bl;
      // console.log(eventmarket[i]['o'].length);
      for (var j = 0; j < eventmarket[i]['o'].length;j++) {
        // console.log(eventmarket[i]['o'][j].n);
            if(eventmarket[i]['o'][j].n=="1"){
              eventmarket[i]['o'][j].name = "Home";
              eventmarket[i]['o'][j].short_name = "Home";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="2"){
              eventmarket[i]['o'][j].name = "Away";
              eventmarket[i]['o'][j].short_name = "Away";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="X"){
              eventmarket[i]['o'][j].name = "Draw";
              eventmarket[i]['o'][j].short_name = "Draw";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="O"){
              eventmarket[i]['o'][j].name = "Over";
              eventmarket[i]['o'][j].short_name = "Over";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="U"){
              eventmarket[i]['o'][j].name = "Under";
              eventmarket[i]['o'][j].short_name = "Under";
              delete eventmarket[i]['o'][j].n;
            }
            else{
              eventmarket[i]['o'][j].name = eventmarket[i]['o'][j].n;
              eventmarket[i]['o'][j].short_name = eventmarket[i]['o'][j].n;
              delete eventmarket[i]['o'][j].n;
            }
            eventmarket[i]['o'][j].value_eu = eventmarket[i]['o'][j].v;
            if(eventmarket[i].hasOwnProperty('ha')){
              eventmarket[i]['o'][j].handicap = eventmarket[i].ha;
            }
            if(eventmarket[i].id=="1777"){
              if(eventmarket[i]['o'][0].short_name=="Away"){
                temp = eventmarket[i]['o'][0];
                eventmarket[i]['o'][0] = eventmarket[i]['o'][2];
                eventmarket[i]['o'][2] = temp;
              }
            }
            eventmarket[i].participants = eventmarket[i]['o'];
            // delete eventmarket[i]['o'];
      }
  }
  return eventmarket;
}
function makeExtra(event) {
  let me = event.m;
  let finalMin = getHRMIN(event.tm);
  let min      = finalMin.split(":")[0];
  min = parseInt(min)+1;
  for (var i = 0; i < me.length; i++) {
      me[i].minute = min;
        if(me[i].n.includes("Goal")==true && me[i].n.includes("Goals")==false){
          me[i].code = 2;
        }
        if(me[i].n.includes("Goal Kicks")==true){
          me[i].code = 10;
        }
        if(me[i].n.includes("Free Kicks")==true){
          me[i].code = 20;
        }
        if(me[i].n.includes("Throw Ins")==true){
          me[i].code = 30;
        }
        if(me[i].n.includes("Cards")==true){
          me[i].code = 40;
        }
        if(me[i].n.includes("Corners")==true && me[i].n.includes("Race")==false){
          me[i].code = 50;
        }
        if(me[i].n.includes("Goals")==true){
          me[i].code = 60;
        }

        if(me[i].n.includes("Corner")==true && me[i].n.includes("Corners")==false){
          me[i].code = 7;
        }
        if(me[i].n.includes("Substitution")){
          me[i].code = 3;
        }
        if(me[i].n.includes("Yellow Card")){
          me[i].code = 4;
        }
        if(me[i].n.includes("Red Card")){
          me[i].code = 5;
        }
        if(me[i].n.includes("Score at the end of First Half")){
          me[i].code = 1;
        }

  }
  return me;
}
function makeStructure(event) {
  let update_ts = Math.floor(Date.now()/1000);
  let pt = Math.floor(event.pt/1000);
  let nc  = 0;
  let finished = 0;
  if(array_key_exists('nc',event)){
    nc = 1;
  }
  if(event.pc==255){
    finished = 1;
  }
  let core = {"safe":1,"removed":0,"nc":nc,"stopped":event.bl,"blocked":event.bl,"finished":finished,"updated_ts":update_ts,"pt":pt,"dt":event.dt};
  let finalMin = getHRMIN(event.tm);
  let min      = finalMin.split(":")[0];
  min = parseInt(min)+1;
  let leagueName   = event.lg==""?event.cn:get_league(event.lg);
  let lid = event.lg==""?event.cn:event.lg;
  if(!leagueName){
    leagueName = "World "+getSportName(event.sp);
  }
  let info = {"id":event.ei,"flag":getFlag(event),"ct":event.ct,"lid":lid,"league":leagueName,"name":getMatchBetween(event),"sport":getSportName(event.sp),
              "period":getPeriod(event),"country":getCountry(event),"score":getScore(event),"minute":min,"tm":event.tm,
              "seconds":finalMin,"state":event.sc,"fi":event.fi,"MID":event.MID};
  let team_info = {"home":event.T1.n,"away":event.T2.n};
  let stats =  makeStates(event);
  let extra = makeExtra(event);
  let odds = makeOdds(event);
  // console.log(odds[0]['participants']);
  let match = {"core":core,"info":info,"team_info":team_info,"extra":extra,"odds":odds,"stats":stats};
  // console.log(match);
  let finalData = {"match":match,"sport":event.sp,"eventId":event.ei};
  if(odds){
    save_live_feed(finalData);
    // save_live_feed_atlas(finalData);
  }

  // let rawdata   = {"match":event,"sport":event.sp,"eventId":event.ei};
  if(event.sp==1 || event.sp==13 || event.sp==91 || event.sp==18){
    save_result(finalData);
    let sTabData = {"eventId":event.ei,"sp":event.sp};
    subsriptionTableFun(sTabData);
    if(info.period=="Finished"){
      removed_finish_match(finalData);
    }
    // save_result_atlas(finalData);
  }
  // save_raw_feed(rawdata);
  // finalData = JSON.stringify(finalData);
  // client.set('betradder_temp', finalData);
  //
  // return finalData;
}
async function subsriptionTableFun(rawdata) {
  // MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  //     if (err) throw err;
  //     var dbo = db.db("winpars_db");
  //     var myquery = { eventId: rawdata.eventId };
  //     var newvalues = { $set: rawdata };
  //     dbo.collection("subsriptionTable").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
  //         if (err) throw err;
  //         // console.log("1 document updated");
  //         db.close();
  //     });
  //   });
  const filter = { eventId: rawdata.eventId };
  const update = rawdata;

  let eachpush = await subsriptionTable.findOneAndUpdate(filter,update,{
    new : true,
    upsert : true
  })
  // console.log(eachpush)
}
function save_raw_feed(rawdata) {
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
      if (err) throw err;
      var dbo = db.db("winpars_db");
      var myquery = { eventId: rawdata.eventId };
      var newvalues = { $set: rawdata };
      dbo.collection("betradereachpushraw").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
          if (err) throw err;
          // console.log("1 document updated");
          db.close();
      });
    });
}
async function save_result(finalData) {
  // MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  //     if (err) throw err;
  //     var dbo = db.db("winpars_db");
  //     delete finalData.match.odds;
  //     let resultdata = {
  //       "matchId" : finalData.eventId,
  //       "sport"   : finalData.match.info.sport,
  //       "fi"      : finalData.match.info.fi,
  //       "MID"     : finalData.match.info.MID,
  //       "NC"      : finalData.match.core.nc,
  //       "results" : finalData.match
  //     }

  //     var myquery = { eventId: finalData.eventId };
  //     var newvalues = { $set: resultdata };
  //     dbo.collection("betraderresults").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
  //         if (err) throw err;
  //         // console.log("1 document updated");
  //         db.close();
  //     });
  //   });

      delete finalData.match.odds;
          let resultdata = {
            "matchId" : finalData.eventId,
            "sport"   : finalData.match.info.sport,
            "fi"      : finalData.match.info.fi,
            "MID"     : finalData.match.info.MID,
            "NC"      : finalData.match.core.nc,
            "results" : finalData.match
          }
      const filter = { eventId: finalData.eventId };
      const update = resultdata;

      let eachpush = await betraderresults.findOneAndUpdate(filter,update,{
        new : true,
        upsert : true
})
// console.log(eachpush)
}
function save_result_atlas(finalData) {
    let atlas_url = "mongodb+srv://mongouser:dbZCiED9F65gAbKc@cluster0.otpkk.mongodb.net/?retryWrites=true&w=majority";
  MongoClient.connect(atlas_url, {useNewUrlParser: true, useUnifiedTopology: true },function(err, db) {
      if (err) throw err;
      var dbo = db.db("winpars_db");
      delete finalData.match.odds;
      let resultdata = {
        "matchId" : finalData.eventId,
        "sport"   : finalData.match.info.sport,
        "fi"      : finalData.match.info.fi,
        "MID"     : finalData.match.info.MID,
        "NC"      : finalData.match.core.nc,
        "results" : finalData.match
      }

      var myquery = { eventId: finalData.eventId };
      var newvalues = { $set: resultdata };
      dbo.collection("betraderresults").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
          if (err) throw err;
          // console.log("1 document updated");
          db.close();
      });
    });
}
async function removed_finish_match(finalData) {
  // MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
  //     if (err) throw err;
  //     var dbo = db.db("winpars_db");
  //     var myquery = { eventId: finalData.eventId.toString()  };
  //     // var newvalues = { $set: finalData };
  //     // var myquery = { address: 'Mountain 21' };
  //     dbo.collection("betradereachpush").deleteOne(myquery, function(err, obj) {
  //         if (err) throw err;
  //         // console.log("1 document deleted");
  //         db.close();
  //     });
  //   });
  var myquery = { eventId: finalData.eventId.toString()  };
  let response = await betradereachpush.deleteOne(myquery);
}
function save_live_feed_atlas(finalData){
    let atlas_url = "mongodb+srv://mongouser:dbZCiED9F65gAbKc@cluster0.otpkk.mongodb.net/?retryWrites=true&w=majority";
    MongoClient.connect(atlas_url, { useNewUrlParser: true,useUnifiedTopology: true },function(err, db) {
        if (err) throw err;
        var dbo = db.db("winpars_db");
        var myquery = { eventId: finalData.eventId };
        var newvalues = { $set: finalData };
        dbo.collection("betradereachpush").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
            if (err) throw err;
            // console.log("1 document updated");
            db.close();
        });
      });
}
async function save_live_feed(finalData){

    // MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
    //     if (err) throw err;
    //     var dbo = db.db("winpars_db");
    //     var myquery = { eventId: finalData.eventId };
    //     var newvalues = { $set: finalData };
    //     dbo.collection("betradereachpush").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
    //         if (err) throw err;
    //         // console.log("1 document updated");
    //         db.close();
    //     });
    //   });
    const filter = { eventId: finalData.eventId };
    const update = finalData;

    let eachpush = await betradereachpush.findOneAndUpdate(filter,update,{
      new : true,
      upsert : true
    })

    // console.log(eachpush)
}

async function save_live_raw_data(data){
  const filter = { eventId: data.ei };
    const update = {eventId:data.ei ,sport:data.sp,match:data};

    let eachpush = await Betradereachpushraw.findOneAndUpdate(filter,update,{
      new : true,
      upsert : true
    })
}


exports.process_feed = function(feed){
  feed = JSON.parse(feed);
  if(feed.D=="UE"){
    if(feed.sp==1){
      // save_live_raw_data(feed)
      return makeStructure(feed);

    }
  }

}


// process_feed();
