const league = require('./league.js');
const period = require('./period.js');
const countryCode = require('./countryCode.js');
const market = require('./market.js');
const stats = require('./stats.js');
const country = require('./country.js');
var MongoClient = require('mongodb').MongoClient;
var url = "mongodb://winpars-user:3lc_KYZqRL9G1IVjY-qKsfit@localhost:27017/winpars_db";
var redis = require('redis');
var client = redis.createClient();
var leagues      = league.leagues().league;
var periods      = period.periods().period;
var countryCodes = countryCode.countryCodes().countryCode;
var markets      = market.markets().market;
var statss       = stats.stats().stats;
var countries    = country.countries().country;


function getHRMIN(tm) {
  let hr = Math.floor(tm/3600);
  let min = Math.floor(tm/60);
  min = min+hr;
  let sec = tm%60;
  let final = min+':'+sec;
  return final;
}
function getCountry(event) {
  let country_map = countryCodes[event.sp];
  // console.log(country_map);
  // return country_map[event.lg].code;
  if(array_key_exists(event.lg,country_map)){
    return country_map[event.lg].code;
  }else if (country_map[event.lg]!==undefined) {
    return country_map[event.lg].code;
  }else{
    return "team";
  }
}
function get_league(id){
  for (var i = 0; i < leagues.length; i++) {
    if(leagues[i].ID==id){
      for (var j = 0; j < countries.length; j++) {
        if(countries[j].ID==leagues[i].C){
          return countries[j].Name+' '+leagues[i].Name;
        }
      }

    }
  }
}
function getPeriod(event) {
  for (var i = 0; i < periods.length; i++) {
    // console.log(periods[i]);
    if(periods[i].pc==event.pc && periods[i].s==event.sp){
      return periods[i].pcName;
    }
  }
}
function getScore(event) {
  if(event.sp==1){
    return event.stats['a'][0]+':'+event.stats['a'][1];
  }
  if(event.sp==18){
    // console.log(event.stats);

    if(array_key_exists('T',event.stats)){
      return event.stats['T'][0]+':'+event.stats['T'][1];
    }else if (event.stats['T']!==undefined) {
      return event.stats['T'][0]+':'+event.stats['T'][1];

    }else{
      return '0:0';
    }

  }
  if(event.sp==13){
    var score = new Array();
    var stats = event.stats;
    for (var i = 0; i < stats.length; i++) {
        if(stats[i].name.includes("S")){
          score.push(stats[i][0]+':'+stats[i][1]);
        }
    }
    return score.join();
  }
  if(event.sp==91){
    var home = 0;
    var away = 0;
    var stats = event.stats;
    for (var i = 0; i < stats.length; i++) {
        if(stats[i].name.includes("S")){
          if(stats[i][0]>stats[i][1]){
            home++;
          }
          if(stats[i][0]<stats[i][1]){
            away++;
          }
        }
    }
    return home+':'+away;
  }
}

function getMatchBetween(event) {
  return event.T1.n+' vs '+event.T2.n;
}
function getSportName(id) {
  if(id==1){
    return "Football";
  }
  if(id==13){
    return "Tennis";
  }
  if(id==18){
    return "Basketball";
  }
  if(id==91){
    return "Volleyball";
  }
}
function makeStates(event) {
  let data = new Array();
  let stats = event.stats;
  data.push({"Name":"Team","home":event.T1.n,"away":event.T2.n});
  // for (var i = 0; i < stats.length; i++) {
  //
  // }
  Object.keys(stats).forEach(function(key) {
  // console.log('Key : ' + key + ', Value : ' + stats[key])
      for (var j = 0; j < statss.length; j++) {
          if(key==statss[j].c && statss[j].s==event.sp){
            data.push({"Name":statss[j].e,"home":stats[key][0],"away":stats[key][1]});
          }
      }
    })
  return data;
}
function array_key_exists(needle, haystack) {
    // var length = haystack.length;
    // for(var i = 0; i < length; i++) {
    //     if(haystack[i] == needle) return true;
    // }
    // return false;
      var flag = false;
      // if(Array.isArray(haystack)){
      if(typeof haystack === 'object' && haystack !== null){
        Object.keys(haystack).forEach(function(key) {
          if(key==needle){
            flag  = true;
          }
        });
      }

    return flag;
}
function makeOdds(event) {
  let livemarkets = markets[event.sp];
  // console.log(markets);
  let eventmarket = event.ma;
  for (var i = 0; i < eventmarket.length; i++) {
      if(array_key_exists(eventmarket[i].id,livemarkets)){
        eventmarket[i].name =livemarkets[eventmarket[i].id];
        eventmarket[i].short_name = livemarkets[eventmarket[i].id];
      }else if (livemarkets[eventmarket[i].id]!==undefined) {
        eventmarket[i].name =livemarkets[eventmarket[i].id];
        eventmarket[i].short_name = livemarkets[eventmarket[i].id];
      }else{
        eventmarket[i].name = 'Market Not Defined';
        eventmarket[i].short_name = 'Market Not Defined';
      }

      if(array_key_exists('ha',eventmarket[i])){
        eventmarket[i].handicap = eventmarket[i].ha;
      }
      // eventmarket[i].name =markets[eventmarket[i].id];
      // eventmarket[i].short_name = markets[eventmarket[i].id];
      eventmarket[i].suspend =eventmarket[i].bl;
      // console.log(eventmarket[i]['o'].length);
      for (var j = 0; j < eventmarket[i]['o'].length;j++) {
        // console.log(eventmarket[i]['o'][j].n);
            if(eventmarket[i]['o'][j].n=="1"){
              eventmarket[i]['o'][j].name = "Home";
              eventmarket[i]['o'][j].short_name = "Home";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="2"){
              eventmarket[i]['o'][j].name = "Away";
              eventmarket[i]['o'][j].short_name = "Away";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="X"){
              eventmarket[i]['o'][j].name = "Draw";
              eventmarket[i]['o'][j].short_name = "Draw";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="O"){
              eventmarket[i]['o'][j].name = "Over";
              eventmarket[i]['o'][j].short_name = "Over";
              delete eventmarket[i]['o'][j].n;
            }
            else if(eventmarket[i]['o'][j].n=="U"){
              eventmarket[i]['o'][j].name = "Under";
              eventmarket[i]['o'][j].short_name = "Under";
              delete eventmarket[i]['o'][j].n;
            }
            else{
              eventmarket[i]['o'][j].name = eventmarket[i]['o'][j].n;
              eventmarket[i]['o'][j].short_name = eventmarket[i]['o'][j].n;
              delete eventmarket[i]['o'][j].n;
            }
            eventmarket[i]['o'][j].value_eu = eventmarket[i]['o'][j].v;
            if(eventmarket[i].hasOwnProperty('ha')){
              eventmarket[i]['o'][j].handicap = eventmarket[i].ha;
            }
            if(eventmarket[i].id=="1777"){
              if(eventmarket[i]['o'][0].short_name=="Away"){
                temp = eventmarket[i]['o'][0];
                eventmarket[i]['o'][0] = eventmarket[i]['o'][2];
                eventmarket[i]['o'][2] = temp;
              }
            }
            eventmarket[i].participants = eventmarket[i]['o'];
            // delete eventmarket[i]['o'];
      }
  }
  return eventmarket;
}
function makeExtra(event) {
  let me = event.m;
  let finalMin = getHRMIN(event.tm);
  let min      = finalMin.split(":")[0];
  min = parseInt(min)+1;
  for (var i = 0; i < me.length; i++) {
      me[i].minute = min;
        if(me[i].n.includes("Goal")==true && me[i].n.includes("Goals")==false){
          me[i].code = 2;
        }
        if(me[i].n.includes("Goal Kicks")==true){
          me[i].code = 10;
        }
        if(me[i].n.includes("Free Kicks")==true){
          me[i].code = 20;
        }
        if(me[i].n.includes("Throw Ins")==true){
          me[i].code = 30;
        }
        if(me[i].n.includes("Cards")==true){
          me[i].code = 40;
        }
        if(me[i].n.includes("Corners")==true && me[i].n.includes("Race")==false){
          me[i].code = 50;
        }
        if(me[i].n.includes("Goals")==true){
          me[i].code = 60;
        }

        if(me[i].n.includes("Corner")==true && me[i].n.includes("Corners")==false){
          me[i].code = 7;
        }
        if(me[i].n.includes("Substitution")){
          me[i].code = 3;
        }
        if(me[i].n.includes("Yellow Card")){
          me[i].code = 4;
        }
        if(me[i].n.includes("Red Card")){
          me[i].code = 5;
        }
        if(me[i].n.includes("Score at the end of First Half")){
          me[i].code = 1;
        }

  }
  return me;
}
function makeStructure(event) {
  let update_ts = Math.floor(Date.now()/1000);
  let nc  = 0;
  let finished = 0;
  if(array_key_exists('nc',event)){
    nc = 1;
  }
  if(event.pc==255){
    finished = 1;
  }
  let core = {"safe":1,"removed":0,"nc":nc,"stopped":event.bl,"blocked":event.bl,"finished":finished,"updated_ts":update_ts};
  let finalMin = getHRMIN(event.tm);
  let min      = finalMin.split(":")[0];
  min = parseInt(min)+1;
  let leagueName   = event.lg==""?event.cn:get_league(event.lg);
  if(!leagueName){
    leagueName = "World "+getSportName(event.sp);
  }
  let info = {"id":event.ei,"league":leagueName,"name":getMatchBetween(event),"sport":getSportName(event.sp),
              "period":getPeriod(event),"country":getCountry(event),"score":getScore(event),"minute":min,"tm":event.tm,
              "seconds":finalMin,"state":event.sc,"fi":event.fi,"MID":event.MID};
  let team_info = {"home":event.T1.n,"away":event.T2.n};
  let stats =  makeStates(event);
  let extra = makeExtra(event);
  let odds = makeOdds(event);
  // console.log(odds[0]['participants']);
  let match = {"core":core,"info":info,"team_info":team_info,"extra":extra,"odds":odds,"stats":stats};
  // console.log(match);
  let finalData = {"match":match,"sport":event.sp,"eventId":event.ei};
  save_live_feed(finalData);
  let rawdata   = {"match":event,"sport":event.sp,"eventId":event.ei};
  // save_raw_feed(rawdata);
  // finalData = JSON.stringify(finalData);
  // client.set('betradder_temp', finalData);
  //
  // return finalData;
}
function save_raw_feed(rawdata) {
  MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
      if (err) throw err;
      var dbo = db.db("winpars_db");
      var myquery = { eventId: rawdata.eventId };
      var newvalues = { $set: rawdata };
      dbo.collection("betradereachpushraw").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
          if (err) throw err;
          // console.log("1 document updated");
          db.close();
      });
    });
}
function save_live_feed(finalData){

    MongoClient.connect(url, { useUnifiedTopology: true },function(err, db) {
        if (err) throw err;
        var dbo = db.db("winpars_db");
        var myquery = { eventId: finalData.eventId };
        var newvalues = { $set: finalData };
        dbo.collection("bgeachpush").updateOne(myquery, newvalues,{upsert : true}, function(err, res) {
            if (err) throw err;
            // console.log("1 document updated");
            db.close();
        });
      });

    // MongoClient.connect(url,{ useUnifiedTopology: true } , function(err, db) {
    //   if (err) throw err;
    //   var myquery = { eventId: finalData.eventId };
    //   var dbo = db.db("winpars_db");
    //   dbo.collection("betradereachpush").deleteMany(myquery, function(err, obj) {
    //     if (err) throw err;
    //     // console.log(obj.result.n + " document(s) deleted");
    //     db.close();
    //   });
    // });
    //
    // MongoClient.connect(url,{ useUnifiedTopology: true } , function(err, db) {
    //   if (err) throw err;
    //   var dbo = db.db("winpars_db");
    //   // var myobj = JSON.stringify(finalData);
    //   dbo.collection("betradereachpush").insertOne(finalData, function(err, res) {
    //     if (err) throw err;
    //     // console.log("1 document inserted");
    //     db.close();
    //   });
    // });
}
exports.process_feed = function(feed){
  feed = JSON.parse(feed);
  if(feed.D=="UE"){
    if(feed.sp==1 || feed.sp==18 || feed.sp==13 || feed.sp==91){
      return makeStructure(feed);

    }
  }

}


// process_feed();
